#include <map>
#include <set>
#include <ext/slist>

namespace
{
    struct Manager
    {
        std::set<char* > Used;
        __gnu_cxx::slist<char* > Free;
        unsigned size;
        
        char* Create() const
        {
            return new char[size];
        }
    public:
        Manager(unsigned s) : size(s)
        {
        }
        
        char* pick()
        {
            char* result = NULL;
            if(Free.empty())
            {
                result = Create();
            }
            else
            {
                result = *Free.begin();
                Free.pop_front();
            }
            Used.insert(result);
            return result;
        }
        void free(char* ptr)
        {
            Used.erase(ptr);
            Free.push_front(ptr);
        }
    };

    std::map<unsigned, Manager* > Managers;
    
    Manager& GetManager(unsigned size)
    {
        std::map<unsigned, Manager *>::iterator i = Managers.find(size);
        if(i != Managers.end()) return *i->second;
        
        Manager* m = new Manager(size);
        Managers.insert(std::make_pair(size, m));
        return *m;
    }
}

char* Allocate(unsigned size)
{
    //return new char[size];
    return GetManager(size).pick();
}

/* Note: Partial unallocation is not allowed. */
void Unallocate(char* ptr, unsigned size)
{
    //delete[] ptr;
    GetManager(size).free(ptr);
}

